if ($Pref::Server::VehicleCollisionIntegration $= "")
    $Pref::Server::VehicleCollisionIntegration = 64;

// Call this function if you change the preference while the server is running.
function applyVehicleCollisionFix()
{
    // Anything anywhere close to 512 will likely burn your server to the
    // ground. If you need a free heater, feel free to remove the limit here.
    %integration = mClamp($Pref::Server::VehicleCollisionIntegration, 1, 512);
    echo("Applying vehicle integration of " @ %integration @ " to all vehicles");

    %dataCount = DataBlockGroup.getCount();

    for (%i = 0; %i < %dataCount; %i++)
    {
        %data = DataBlockGroup.getObject(%i);
        %type = %data.getClassName();

        if (%type $= "WheeledVehicleData" ||
            %type $= "FlyingVehicleData" ||
            %type $= "HoverVehicleData")
        {
            %data.integration = %integration;
        }
    }

    // Inform clients of the new integration property.
    %clientCount = ClientGroup.getCount();

    for (%i = 0; %i < %clientCount; %i++)
    {
        %client = ClientGroup.getObject(%i);

        if (%client.hasSpawnedOnce || %client.currentPhase > 1)
        {
            // Not using transmitDataBlocks() because it displays a message,
            // and because it messes up when people are already loading.
            %client.transmitDataBlocks(1);
        }
    }
}

package VehicleCollisionFix
{
    function verifyBrickUiNames()
    {
        // Apply the fix after all add-ons have loaded.
        applyVehicleCollisionFix();
        Parent::verifyBrickUiNames();
    }
};

activatePackage("VehicleCollisionFix");
